print ("StatusPlus : GetActionString patch")

require "bufferedaction"
--require "rincewind/craputil"

local oldGetActionString = GetActionString

function GetActionString(action, modifier, target)
	local s = oldGetActionString(action,modifier)
--	print("GetActionString("..tostring(action)..", "..tostring(modifier)..", "..tostring(target).."  Default s = "..tostring(s))
--	if target and action and (type(action)=="string") and ((action == "ATTACK") or (action == "FORCEATTACK")) then
	if target and action and (type(action)=="string") then
		if action == "SIGNEDIT" then -- ugly solution ....dunno why old get action string not work for signplus :/
			if target.components and  target.components.signdata and target.components.signdata.data and
				target.components.signdata.data.str and (type(target.components.signdata.data.str)=="string") then
				if string.len(target.components.signdata.data.str) > 0 then 
--					s = "("..string.gsub(target.components.signdata.data.str, "%s+", " ")..") " 
					s = string.gsub(target.components.signdata.data.str, "%s+", " ")
				end
			end
		
		end

--		print("GetActionString("..tostring(action)..", "..tostring(modifier)..", "..tostring(target))
--		if target.components and target.components.health and action ~= "REPAIR" and action ~="OPEN" and action~="CLOSE" then
		if target.components and target.components.health and (action == "ATTACK" or action == "FORCEATTACK" or action == "LOOKAT" or action == "TALK") then
			local h = target.components.health
			local m = h:GetMaxHealth()
			if not m or type(m)~="number" or m < 0 then m = 0 end
			local c = h:GetPercent()	-- function can return different value from h.max, so proper way is to call methods instead using values directly
			if not c or type(c)~="number" or c < 0 then c = 0 else c = c*m end
			local news = tostring(math.floor(c+0.5)).." / "..tostring(math.floor(m+0.5))
--			print("GetActionString health : "..news)
			s = s .. "\n" .. news
			if not ((action == "ATTACK") or (action == "FORCEATTACK")) then s = s .. "\n" end
			local p = GetPlayer()
			if p and p.HUD and p.HUD.controls and p.HUD.controls.status and p.HUD.controls.status.monsterstats then
				local ms = p.HUD.controls.status.monsterstats
				if type(ms)=="table" then
					ms.target = target
					ms.hpstr = news
				end
			end
		end
		
	end
	return s
end


function BufferedAction:GetActionString()
--	print("StatusPlus's Buffered action")
	if self.doer and self.doer.ActionStringOverride then
        	local str = self.doer.ActionStringOverride(self.doer, self)
        	if str then return str end
    	end
    	local modifier = nil
	if self.action.strfn then modifier = self.action.strfn(self) end
    	return GetActionString(self.action.id, modifier, self.target)
end

