mdir = "statusplus"
rdir = mdir.."/"
sdir = "scripts/"..rdir
idir = "images/"..rdir

modstr = "StatusPlus : "

modimport (sdir.."_main.lua")
require "util"
require ("rincewind/craputil")
modimport (sdir.."_require.lua")

cfgChangeBoat 		= IsModConfig("Always show boat value")
cfgHideCombinedStatus	= IsModConfig("Hide Comb. Status widgets")
cfgShowYamcheStatus 	= IsModConfig("Show Yamche's widgets")
cfgHIDWidgets		= IsModConfig("Hero in the Dark widgets")
cfgShowMonsterHealth	= IsModConfig("Monster health")

IsMoisture 	= IsDLC
IsGlommer  	= IsDLC
IsBoat		= IsDLC2 and cfgChangeBoat

modimport (sdir.."_spo.lua")
modimport (sdir.."_misc.lua")
modimport (sdir.."_inject.lua")
modimport (sdir.."_hidstat.lua")
modimport (sdir.."_tweak.lua")
modimport (sdir.."_tweakstatus.lua")
modimport (sdir.."_saveload.lua")

----------------------------------------------------------------------------------------------------------------------------

local w,h = TheSim:GetScreenSize()
print (modstr.."Game window resolution is "..tostring(w).."x"..tostring(h))
SResolution(h)
SInitSPData()

if IsBoat then
	AddClassPostConstruct("widgets/boatbadge", 	TweakBoatBadge)
end

AddClassPostConstruct("widgets/tempbadge",		TweakBadge)
AddClassPostConstruct("widgets/krampusbadge",		TweakBadge)
AddClassPostConstruct("widgets/hpbadge",		TweakBadge)
AddClassPostConstruct("widgets/shungerbadge",		TweakBadge)
AddClassPostConstruct("widgets/mushastaminabadge",	TweakMushaStaminaBadge)
AddClassPostConstruct("widgets/mushafatiguebadge",	TweakMushaFatigueBadge)
AddClassPostConstruct("widgets/mushamusicbadge", 	TweakMushaMusicBadge)
AddClassPostConstruct("widgets/statusdisplays",		TweakStatusDisplays)

AddComponentPostInit("kramped",TweakKramped)
AddPrefabPostInit("world", SPAddComponent)

AddSimPostInit(SPostInit)
