MATH_PREC 	= 0.01 --less is considered as zero
spDelimer 	= " / "
spBadgeSize 	= 80 	-- size of spBadgeSize
spBarSize 	= 256	-- bar size
spCurrentWidget = 0
spWidget 	= {}
spWidgetOrder 	= {}
spWidgetName 	= {}
spWidgetSnap 	= 10

-------------------------------------------------------------------------------------------------------------------------------------

spo 		= {}		-- options
spo.wcol	= 5		-- widgets in one default column
spo.scale 	= 0.7		-- widget scale
spo.barscale 	= 0.7		-- bar length scale
spo.mouse 	= true		-- left mouse button click on widget opens options menu
spo.color 	= "default"	-- color scheme
spo.keycode	= KEY_E		-- ALT + keycode = options menu
spo.xoffset	= 0		-- offset for X coord of widget (for default/reset)
spo.yoffset	= 0		-- offset for Y coord of widget (for default/reset)
spo.coffset	= 0		-- offset for X coord of widget between columns
spo.enablebar	= true		-- enable frame behind bar
spo.enablefg	= true		-- enable foreground bar
spo.enablebg	= true		-- enable background bar
spo.enablenum	= true		-- enable numbers on bar

spo.sanity 	= {text = "Sanity", data = true}
spo.health 	= {text = "Health", data = true}
spo.hunger 	= {text = "Hunger", data = true}
spo.moisture 	= {text = "Moisture (DLC)", data = true}
spo.temp 	= {text = "Temperature", data = true}
spo.krampus 	= {text = "Naughtiness", data = false}
spo.chester	= {text = "Chester's HP", data = false}
spo.beaver 	= {text = "Beaverness", data = false}
spo.abigail	= {text = "Abigail's HP", data = false}
spo.glommer	= {text = "Glommer's HP (DLC)", data = false}
spo.wxlevel	= {text = "WX78's LVL", data = false}

spo.sunshine	= {text = "Sunshine (MOD)", data = false}
spo.linkmagick	= {text = "Link's magick (MOD)", data = false}
spo.sneak	= {text = "Sneak (MOD)", data = false}
spo.yamche	= {text = "Yamche's HP (MOD)", data = false}
spo.yamcheh	= {text = "Yamche's hunger (MOD)", data = false}
spo.mstamina	= {text = "Musha's Stamina (MOD)", data = false}
spo.mfatigue	= {text = "Musha's Fatigue (MOD)", data = false}
spo.mmusic	= {text = "Musha's Music (MOD)", data = false}

-- Hero in the Dark
spo.drunk		= {text = "Intoxication (MOD)", data = false}
spo.playerstats		= {text = "Player's stats", data = false}
spo.monsterstats	= {text = "Monster's stats", data = cfgHIDWidgets}
spo.playermagic		= {text = "Player's magic", data = false}

if cfgShowMonsterHealth then
	require (rdir.."statusgetstring")
else
	spo.monsterstats.data = false
end

spdata = {}

local k = "default"

spDefaultPoisonColor = "A1FF00"

spcolor = {}
spcolor[k] = {}
spcolor[k]["g"] 	= "42531E"	--green
spcolor[k]["y"] 	= "D07921"	--yellow
spcolor[k]["r"] 	= "9F2D26"	--red
spcolor[k]["b"] 	= "4A536B"	--blue
spcolor[k]["w"] 	= "B59A6B"	--white
spcolor[k]["p"] 	= spDefaultPoisonColor	--poisoned

k = "bright"
spcolor[k] = {}
spcolor[k]["g"] 	= "21C642"
spcolor[k]["y"] 	= "D2C724"
spcolor[k]["r"] 	= "D22436"
spcolor[k]["b"] 	= "2481D2"
spcolor[k]["w"] 	= "C9C9C9"
spcolor[k]["p"] 	= spDefaultPoisonColor

k = "greyscale"
spcolor[k] = {}
spcolor[k]["g"] 	= "8D8D8D"
spcolor[k]["y"] 	= "DFDFDF"
spcolor[k]["r"] 	= "4D4D4D"
spcolor[k]["b"] 	= "7B7B7B"
spcolor[k]["w"] 	= "DCDCDC"
spcolor[k]["p"] 	= spDefaultPoisonColor

k = "greenonly"
spcolor[k] = {}
spcolor[k]["g"] 	= "42531E"
spcolor[k]["y"] 	= spcolor[k]["g"]
spcolor[k]["r"] 	= spcolor[k]["g"]
spcolor[k]["b"] 	= "1D49D8"
spcolor[k]["w"] 	= "B59A6B"
spcolor[k]["p"] 	= spDefaultPoisonColor

