local mdir = "statusplus"
local rdir = mdir.."/"
local idir = "images/"..rdir

local Widget = require "widgets/widget"
--local Text = require "widgets/text"
--local easing = require "easing"

local KrampusBadge = Class(Widget, function(self, owner)
	Widget._ctor(self, "KrampusBadge")
	self.owner = owner
	self:SetScale(1,1,1)

	self.icon = self:AddChild(Image(idir.."krampus.xml", "krampus.tex"))
	self.icon:SetScale(0.5,0.5,1)
	self.icon:SetPosition(-6,0,0)
	self.dmin = 0
	self.dmax = 0.8

--	self:StartUpdating()
end)

function KrampusBadge:OnUpdate(dt)
end

return KrampusBadge