local mdir = "statusplus"
local rdir = mdir.."/"
local idir = "images/"..rdir

local Widget = require "widgets/widget"

local MushaFatigueBadge = Class(Widget, function(self, owner)
	Widget._ctor(self, "mushastaminameter")
	self.owner = owner
	self:SetScale(1,1,1)

	self.icon = self:AddChild(Image(idir.."mushafatigue.xml", "mushafatigue.tex"))
--	self.icon:SetScale(0.5,0.5,1)
	self.icon:SetPosition(-6,0,0)
--	self.dmin = -0.1
--	self.dmax = -0.1
	self.dmin = 0
	self.dmax = 0
	self.vmin = 0
	self.vmax = 100
end)

function MushaFatigueBadge:OnUpdate(dt)
end

return MushaFatigueBadge
