local mdir = "statusplus"
local rdir = mdir.."/"
local idir = "images/"..rdir

local Widget = require "widgets/widget"

local MushaStaminaBadge = Class(Widget, function(self, owner)
	Widget._ctor(self, "mushastaminameter")
	self.owner = owner
	self:SetScale(1,1,1)

	self.icon = self:AddChild(Image(idir.."mushastamina.xml", "mushastamina.tex"))
--	self.icon:SetScale(0.5,0.5,1)
	self.icon:SetPosition(-6,0,0)
	self.dmin = 0.1
	self.dmax = 0.3
	self.vmin = -0.1
	self.vmax = 100
end)

function MushaStaminaBadge:OnUpdate(dt)
end

return MushaStaminaBadge
